﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Documents.Excel;
using System.Diagnostics;
using System.IO;
using Infragistics.Documents.Reports.Report;
using Infragistics.Documents.Reports.Report.Section;
using Infragistics.Documents.Reports.Report.Shapes;

namespace WinGridExportingSeveralFormat
{
    public partial class Form1 : Form
    {
        Dictionary<string, string> format = new Dictionary<string, string>();
        string selctedFormat = "Excel2007";
        public DataSet GenerateDataSet()
        {
            DataTable table0 = new DataTable("Treatment Fluu");
            table0.Columns.Add("ID", typeof(int));
            table0.Columns.Add("Dosage", typeof(int));
            table0.Columns.Add("Drug", typeof(string));
            table0.Columns.Add("Patient", typeof(string));
            table0.Columns.Add("Date", typeof(DateTime));

            table0.Rows.Add(1, 25, "Indocin", "David", DateTime.Now);
            table0.Rows.Add(2, 50, "Enebrel", "Sam", DateTime.Now);
            table0.Rows.Add(3, 10, "Hydralazine", "Christoff", DateTime.Now);
            table0.Rows.Add(4, 21, "Combivent", "Janet", DateTime.Now);
            table0.Rows.Add(5, 100, "Dilantin", "Melanie", DateTime.Now);

            DataTable table1 = new DataTable("Patient Inof");
            table1.Columns.Add("ID", typeof(int));
            table1.Columns.Add("TFID", typeof(int));
            table1.Columns.Add("Name", typeof(string));
            table1.Columns.Add("Inspection", typeof(string));
            table1.Columns.Add("Date", typeof(DateTime));

            table1.Rows.Add(1, 1, "David", "Control", DateTime.Now);
            table1.Rows.Add(2, 1, "David", "Patient visitation", DateTime.Now);
            table1.Rows.Add(3, 1, "David", "Patient visitation", DateTime.Now);
            table1.Rows.Add(4, 2, "Sam", "Control", DateTime.Now);
            table1.Rows.Add(5, 3, "Christoff", "Control", DateTime.Now);
            table1.Rows.Add(6, 4, "Janet", "Control", DateTime.Now);
            table1.Rows.Add(7, 4, "Janet", "Patient visitation", DateTime.Now);
            table1.Rows.Add(8, 5, "Melanie", "Control", DateTime.Now);
            table1.Rows.Add(9, 5, "Melanie", "Patient visitation", DateTime.Now);


            DataSet RetDataSet = new DataSet();
            RetDataSet.Tables.Add(table0);
            RetDataSet.Tables.Add(table1);
            RetDataSet.Relations.Add(RetDataSet.Tables["Treatment Fluu"].Columns["ID"],
            RetDataSet.Tables["Patient Inof"].Columns["TFID"]);

            return RetDataSet;

        }
        public Form1()
        {
            InitializeComponent();
            ultraGrid1.DataSource = GenerateDataSet();
            format.Add("Excel2007", "Excel2007 (*.xlsx)|*.xlsx");
            format.Add("Excel97To2003", "Excel97To2003 (*.xls)|*.xls");
            format.Add("PDF", "PDF (*.pdf)|*.pdf");
            format.Add("XPS", "XPS (*.xps)|*.xps");
            radioButton1.Text = "Excel2007";
            radioButton2.Text = "Excel97To2003";
            radioButton3.Text = "PDF";
            radioButton4.Text = "XPS";
           // ultraGrid1.DisplayLayout.ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand.Horizontal;
        }

        private void ExportToExcel2007(String path)
        {
            Workbook book = new Workbook(   WorkbookFormat.Excel2007);
            ultraGridExcelExporter1.Export(ultraGrid1, book);
            book.Save(path);
        }

        private void ExportToExcel97To2003(String path)
        {
            Workbook book = new Workbook(WorkbookFormat.Excel97To2003);
            ultraGridExcelExporter1.Export(ultraGrid1, book);
            book.Save(path);
        }

        private void ExportToPDF(String path)
        {
            
            ultraGridDocumentExporter1.Export(ultraGrid1, path, Infragistics.Win.UltraWinGrid.DocumentExport.GridExportFileFormat.PDF);
        }

        private void ExportToXPS(String path)
        {
            ultraGridDocumentExporter1.Export(ultraGrid1, path, Infragistics.Win.UltraWinGrid.DocumentExport.GridExportFileFormat.XPS);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = format[selctedFormat];
            if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                switch (selctedFormat)
                {
                    case "Excel2007":
                        ExportToExcel2007(sfd.FileName);
                        break;
                    case "Excel97To2003":
                        ExportToExcel97To2003(sfd.FileName);
                        break;
                    case "PDF":
                        ExportToPDF(sfd.FileName);
                        break;
                    case "XPS":
                        ExportToXPS(sfd.FileName);
                        break;
                }
                
                Process.Start(sfd.FileName);
            }
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            selctedFormat = ((RadioButton)sender).Text;
        }

        private void ultraGridDocumentExporter1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.DocumentExport.DocumentExportInitializeRowEventArgs e)
        {
            
        }

        private void ultraGridDocumentExporter1_CellExporting(object sender, Infragistics.Win.UltraWinGrid.DocumentExport.CellExportingEventArgs e)
        {
            e.ReportCell.Borders = new Borders( new Infragistics.Documents.Reports.Graphics.Pen( Infragistics .Documents .Reports .Graphics .Colors .Blue , Infragistics.Documents.Reports.Graphics.DashStyle.DashDotDot ));
            
        }

        private void ultraGridDocumentExporter1_RowExporting(object sender, Infragistics.Win.UltraWinGrid.DocumentExport.RowExportingEventArgs e)
        {
           
        }

        private void ultraGridDocumentExporter1_BeginExport(object sender, Infragistics.Win.UltraWinGrid.DocumentExport.BeginExportEventArgs e)
        {
            e.Layout.Override.BorderStyleRow = Infragistics.Win.UIElementBorderStyle.None;
            e.Layout.Override.BorderStyleCell = Infragistics.Win.UIElementBorderStyle.Inset;
        }

        private void ultraGridExcelExporter1_CellExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.CellExportingEventArgs e)
        {
            
        }

        private void ultraGridExcelExporter1_CellExported(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.CellExportedEventArgs e)
        {
            WorksheetCell cell = e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex];
            cell.CellFormat.FormatString = "0.00";

        }

        private void ultraGridExcelExporter1_BeginExport(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.BeginExportEventArgs e)
        {
            e.Layout.ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand.Horizontal;
        }
    }
}
